<html>
  <head>
    <title>SH odjezdy</title>
    <meta charset='UTF-8'>

    <!-- Bootstrap -->
    <link href="./node_modules/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
    <script href='./node_modules/bootstrap/dist/js/bootstrap.bundle.min.js'></script>

    <!-- Custom  stylesheet and JS -->
    <style>
      @media (max-width: 1550px) {
        .departures-table {
          margin-left: 0px!important;
          margin-right: 0px!important;
        }
      }

      @media (min-width: 1550px) {
        .departures-table {
          margin-right: 1.5rem!important;
          margin-left: 1.5rem!important;
        }
      }

      .custom-table-head-container {
        font-weight: bold;
        color: rgb(174, 183, 226);
      }

      .custom-table-body-row-container {
        border-bottom: 2px solid;
        border-color: #393d79;
      }

      .custom-container {
        padding-left: 2%;
        padding-right: 2%;
      }

      #current-time {
        text-align: right;
        font-weight: bold;
        font-size: 60px;
      }

      #last-updated-time {
        text-align: right;
        font-size: 30px;
      }

      .predicted-departure-cell {
        font-weight: bold;
      }

      .custom-text-success {
        color: #5ac39a;
      }

      .custom-text-danger {
        color: #ff9494;
      }

      .custom-text-warning {
        color: #ffdc60;
      }

      .departures-table {
        background-color: #292b6a;
        border-radius: 1rem;
        font-size: 25px;
      }

      .stop-name {
        font-size: 35px;
        font-weight: bold;
      }


      @media (max-width: 1400px) {
        .empty-table {
          display: none;
        }
      }

      @media (min-width: 1550px) {
        .custom-col-xxl {
          flex: 1 0 0%;
        }
      }

      @media (min-width: 1550px) {
        .time-container {
          margin-right: 11px;
        }
      }

      @media (max-width: 1550px) {
        .time-container {
          margin-right: -11px;
        }
      }

      body {
        background-color: #181c56;
        color: white;
        font-family: Helvetica;
      }
    </style>
    <script>
      // Generate your API token at https://api.golemio.cz/api-keys
      const GOLEMIO_API_TOKEN = 'your token goes here';

      const Stop = {
        KOLEJE_STRAHOV: 'U981Z1P',
        STADION_STRAHOV: 'U699Z2P',
        PETRIN: 'U1999Z1P',
      };

      let timeObj, tableObj, lastUpdatedObj, alertObj;

      const showError = (message) => {
        alertObj.innerHTML = `<div class='alert alert-danger'>[${new Date().toLocaleTimeString('cs')}] ${message}</div>`;
      };

      const clearError = () => {
        alertObj.innerHTML = '';
      };

      const updateTime = (timeObj) => {
        const date = new Date();
        const dateString = `${date.toLocaleDateString('cs')} ${date.toLocaleTimeString('cs')}`;
        timeObj.innerText = dateString;
      };

      const updateDepartures = async (stops, tableObj, lastUpdatedObj) => {
        const tables = await Promise.all(stops.map((stopId) => getDepartures(stopId)));

        let tableString = `<div class='row'>`;
        for (let i = 1; i <= tables.length; i++) {
          if (tables[i-1]) {

            tableString += `<div class='custom-col-xxl px-5 py-4 my-4 departures-table'>${tables[i-1]}</div>`;
          }

          if (i%2 === 0) {
            tableString += `</div><div class='row'>`;
          }
        }

        if (tables.length % 2 !== 0) {
          tableString += `<div class='custom-col-xxl px-5 py-4 my-4 departures-table empty-table'></div>`;
        }
        tableString += '</div>';
        tableObj.innerHTML = tableString;

        const date = new Date();
        const dateString = `${date.toLocaleDateString('cs')} ${date.toLocaleTimeString('cs')}`;
        lastUpdatedObj.innerText = `Poslední aktualizace: ${dateString}`;
      };

      const getDepartures = async (stopId) => {
        let response;
        try {
          response = await fetch(
            `https://api.golemio.cz/v2/pid/departureboards/?ids=${stopId}&mode=departures&preferredTimezone=Europe%2FPrague&minutesAfter=1440&limit=5`,
            { headers: { 'X-Access-Token': GOLEMIO_API_TOKEN } },
          );
        } catch (error) {
          showError(error);
          return;
        }

        const json = await response.json();
        console.log(json);

        if (!response.ok) {
          let message;
          if (json.error_status && json.error_message) {
                  message = `API responded with status ${json.error_status}: ${json.error_message}`;
          } else {
            message = 'Something went wrong.'
          }

          showError(message);
          return;
        }

        clearError();

        let tableString = '<div>';
        tableString += `<div class='stop-name'>${json.stops[0].stop_name}</div>`;
        tableString += `
          <div class='row custom-table-head-container'>
             <div class='col-md-5'>Linka</div>
             <div class='col-md-5'>Odjezd</div>
             <div class='col-md-2'>Predikce</div>
          </div>
        `;

        json.departures.forEach((dep) => {
          let delayString;
          let delayColor;
          if (dep.delay.is_available) {
            if (dep.delay.minutes != 0) {
              delayString = `${dep.delay.minutes >= 0 ? '+': ''}${dep.delay.minutes} min`
              delayColor = dep.delay.minutes > 0 ? 'custom-text-danger' : 'custom-text-success';
            } else if (dep.delay.minutes === 0 && dep.delay.seconds !== 0) {
              delayString = `${dep.delay.seconds >= 0 ? '+': ''}${dep.delay.seconds} sec`
              delayColor = dep.delay.seconds > 0 ? 'custom-text-danger' : 'custom-text-success';
            } else {
              delayString = 'včas';
              delayColor = 'custom-text-success';
            }
          } else {
            delayString = 'není k dispozici';
            delayColor = 'custom-text-warning';
          }

          const scheduledDepartureString = new Date(dep.departure_timestamp.scheduled).toLocaleTimeString('cs').padStart(8, '0');
          const actualDepartureString = new Date(dep.departure_timestamp.predicted).toLocaleTimeString('cs').padStart(8, '0');

          row = `
            <div class='col-md-5'>${dep.route.short_name} ${dep.trip.headsign}</div>
            <div class='col-md-5'>${scheduledDepartureString}${dep.delay.is_available ? ` <span class='${delayColor}'>(${delayString})</span>` : ''}</div>
            <div class='col-md-2 ${delayColor} predicted-departure-cell'>${actualDepartureString}</div>
          `;
          tableString += `<div class='row py-2 custom-table-body-row-container'>${row}</div>`;
        });
        tableString += '</div>';

        return tableString;
      };

      const main = () => {
        timeObj = document.getElementById('current-time');
        tableObj = document.getElementById('departures-table-container');
        lastUpdatedObj = document.getElementById('last-updated-time');
        alertObj = document.getElementById('error-alert');

        const jobs = [
          {
            function: updateTime,
            args: [timeObj],
            interval: 1000,
          },
          {
            function: updateDepartures,
            args: [[Stop.KOLEJE_STRAHOV, Stop.STADION_STRAHOV, Stop.PETRIN], tableObj, lastUpdatedObj],
            interval: 10000,
          }
        ];

        jobs.forEach((job) => {
          job.function(...job.args)
          setInterval(job.function, job.interval, ...job.args)
        });
      };

      window.onload = main;
    </script>
  </head>
  <body>
    <div class='container-fluid mt-2 custom-container'>
      <div id='error-alert'></div>
      <div class='time-container'>
        <div class='row'>
          <div id='current-time'></div>
        </div>
        <div class='row'>
          <div id='last-updated-time'></div>
        </div>
      </div>
      <div id='departures-table-container'></div>
    </div>
  </body>
</html>
